﻿using System.Drawing;
using GrapeCity.Documents.Drawing;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Pdf.MarkedContent;
using GrapeCity.Documents.Pdf.Spec;
using GrapeCity.Documents.Pdf.Structure;
using GrapeCity.Documents.Text;
using Image = GrapeCity.Documents.Drawing.Image;


Console.WriteLine("Start!");

string dest = "../../../PDF/simpleTaggedPDF.pdf";

var ip = new PointF(100, 24); // initial point
var tl = new TextLayout(72);

var tftitle = new TextFormat();
tftitle.Font = StandardFonts.TimesBold;
tftitle.Underline = true;
tftitle.FontSize = 24F;

var tfheading = new TextFormat();
tfheading.FontBold = true;
tfheading.Font = StandardFonts.TimesBold;
tfheading.Underline = true;
tfheading.FontSize = 20F;

var tfcontent = new TextFormat();
tfcontent.FontBold = false;
tfcontent.Font = StandardFonts.Times;
tfcontent.FontSize = 12F;

//Create new GcPdfDocument
var doc = new GcPdfDocument();
doc.FontEmbedMode = FontEmbedMode.EmbedSubset;
var lpage = doc.Pages.Add();
var g = lpage.Graphics;

var seDoc = new StructElement("Document") { DefaultPage = lpage, ID = new PdfString("1") };
doc.StructTreeRoot.Children.Add(seDoc);

//TAG IMAGE           
var l = 300; var h = 300;
StructElement seImage = new StructElement("Figure") { DefaultPage = lpage };
Attr thAttrBBox = new Attr();

// The "O" property should be encoded as PDF name object
thAttrBBox.PdfDict.Dict.Add(new PdfName("O"), new PdfName("Layout"));
//thAttrBBox.Properties.Add("O", "Layout");

// The "BBox" property should be encoded as PDF rectangle:
// An array of four numbers in default user space units that shall give the coordinates of the
// left, bottom, right, and top edges, respectively, of the structure element's bounding box
// The PdfArray has constructor accepting RectangleF as parameter
// it encodes the rectangle in correct way
//thAttrBBox.PdfDict.Dict.Add(new PdfName("BBox"), new PdfArray(new float[] { ip.X, ip.Y, l, h }));
thAttrBBox.PdfDict.Dict.Add(new PdfName("BBox"), new PdfArray(new RectangleF(ip.X, ip.Y, l, h)));
//thAttrBBox.Properties.Add("BBox", new float[] { ip.X, ip.Y, l, h });

// after these changes the PAC does not throw exceptions

seImage.Attrs.Add(new AttrRevision(thAttrBBox, 0));
seImage.AlternateDescription = "New Document Image";
seDoc.Children.Add(seImage);

//Draw image in the document as marked content
var image = Image.FromFile("../../../IMG/GrapeCity_logo.png");
g.BeginMarkedContent(new TagMcid("Figure", 1));
g.DrawImage(image, new RectangleF(ip.X, ip.Y, l, h), null, ImageAlign.CenterImage); 
g.EndMarkedContent();
//Add marked content to image element
seImage.ContentItems.Add(new McidContentItemLink(1));

//Mark document as tagged:
doc.MarkInfo.Marked = true;
doc.DocumentInfo.Author = "Author test";
doc.Metadata.Creators.Add("Author test");
doc.DocumentInfo.Title = "Tagged Grapecity PDF";
doc.Metadata.Title = "Tagged Grapecity PDF";
doc.Lang = "en";
doc.ViewerPreferences.DisplayDocTitle = true;

//Save the tagged PDF document:
FileStream fs = new FileStream(dest, FileMode.Create);
doc.Save(fs);

Console.WriteLine("Successfully created tagged PDF document !!!");
